﻿:Namespace TickerPlant

    ⎕IO←⎕ML←1
    DATA←0 5⍴0 ⍝ Symbol, Time, Ask, Bid, Volume

    ∇ Init
      '#.FORM'⎕WC'Form' 'TickerPlant'('Coord' 'Pixel')('Size' 400 800)
      '#.FORM.GRID'⎕WC'Grid'('Posn'(0 0))('Size'(400 800))
      #.FORM.GRID.ColTitles←'Symbol' 'Timestamp' 'Ask' 'Bid' 'Volume'
      #.FORM.GRID.RowTitleWidth←0
      #.FORM.GRID.Values←0 5⍴⊂''
      '#.FORM'⎕WS'Event' 777 'UpdateValues'
      END←0
    ∇
     
    ∇ r←GetQuote symbol;url;rc;headers;data
⍝ Get stock data from Yahoo. Thanks to Google, and:
⍝ http://stackoverflow.com/questions/17245498/get-stock-quotes-from-yahoo-finance-in-json-format-using-a-javascript
     
      fromJSON←7159⌶
      url←'http://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20yahoo.finance.quotes%20where%20symbol%20in%20(%22'
      url,←symbol,'%22)%0A%09%09&env=http%3A%2F%2Fdatatables.org%2Falltables.env&format=json'
     
      (rc headers data)←3↑r←#.Samples.HTTPGet url
      :If 0=rc
          r←(fromJSON data).query.results.quote
          r.⎕DF r.('[',Symbol,' ',LastTradeTime,' ',LastTradeDate,']')
      :Else
          (∊⍕r)⎕SIGNAL 11
      :EndIf
    ∇

    ∇ r←Server symbol;end
⍝ Run tickerplant server
      (↑'Samples' 'HTTPUtils')#.⎕CY'conga' ⍝ We need HTTPGet
      :Repeat
          :Trap 0
              r←0(GetQuote symbol)
          :Else
              r←1(⍕↑⎕DMX.DM)
          :EndTrap
          end←##.{TickerPlant.Update ⍵}r
          ⎕DL 15
      :Until end
    ∇

    ∇ r←Update(fail data);vals;i;new;⎕TRAP;sym
      ⎕TRAP←0 'S'     ⍝ You need this to debug callbacks
      :If fail=1
          ⎕←'*** ERROR ***'data
          r←1 ⋄ →0
      :EndIf
     
      new←data.((LastTradeTime,' ',LastTradeDate)Ask Bid Volume)
      :If (≢vals)≥i←(vals←#.FORM.GRID.Values)[;1]⍳sym←⊂data.Symbol
          vals[i;2 3 4 5]←new
      :Else
          vals⍪←sym,new ⍝ Add new row
          vals←vals[⍋↑vals[;1];] ⍝ sort
      :EndIf
      ⎕NQ'#.FORM' 777 vals
     
      :If END=1 ⋄ ⎕←'END sent' ⋄ :EndIf
      r←END
    ∇
    
    ∇ UpdateValues args
     ⍝ Update from thread which created / owns the GUI
     
      ⎕←3⊃args
      #.FORM.GRID.Values←3⊃args
    ∇

:EndNamespace